/* u_status.cc
 *$Header: /al/acs/src/RCS/c_status.cc,v 8.1 95/04/23 18:19:35 al Exp $
 * Displays the status of the system.  Makes all the calculations associated
 * with allocating memory but does not actually allocate it, unless necessary
 * to make the rest of the calculations.
 *
 *   If "allocate" is changed, this must also be changed.
 */
#include "ecah.h"
#include "error.h"
#include "io.h"
#include "mode.h"
#include "c_comand.h"
#include "u_status.h"
#include "m_matrix.h"
#include "declare.h"
/*--------------------------------------------------------------------------*/
//	void	CMD::status(CS&);
/*--------------------------------------------------------------------------*/
extern BSMATRIXdouble aa;
/*--------------------------------------------------------------------------*/
void CMD::status(CS& cmd)
{ 
  mprintf(IO::mstdout,"ACS   System status\n");
  allocate(sSTATUS);
    
  STATUS::overhead = STATUS::total - STATUS::load - STATUS::lud
    		   - STATUS::back - STATUS::output - STATUS::review;

  mprintf(IO::mstdout,
  "command      --------  last  --------    --------  total  --------\n");
  mprintf(IO::mstdout,
  "               user      sys    total       user      sys    total\n");
  STATUS::get.print();
  STATUS::op.print();
  STATUS::dc.print();
  STATUS::tran.print();
  STATUS::four.print();
  STATUS::ac.print();

  mprintf(IO::mstdout,
  "function     --------  last  --------    --------  total  --------\n");
  mprintf(IO::mstdout,
  "               user      sys    total       user      sys    total\n");
  STATUS::setup.print();
  STATUS::order.print();

  
  mprintf(IO::mstdout,
  "function     --------  last  --------    --------  total  --------\n");
  mprintf(IO::mstdout,
  "               user      sys    total       user      sys    total\n");
  STATUS::load.print();
  STATUS::lud.print();
  STATUS::back.print();
  STATUS::review.print();
  STATUS::output.print();
  STATUS::overhead.print();
  STATUS::total.print();

  mprintf(IO::mstdout,
	  "iterations: op=%d, dc=%d, tran=%d, fourier=%d, total=%d\n",
	  STATUS::iter[sOP], STATUS::iter[sDC], STATUS::iter[sTRAN],
	  STATUS::iter[sFOURIER], STATUS::iter[iTOTAL]);
  mprintf(IO::mstdout,
	  "nodes: user=%d, subckt=%d, model=%d, total=%d\n",
	  STATUS::user_nodes, STATUS::subckt_nodes, STATUS::model_nodes,
	  STATUS::total_nodes);
  mprintf(IO::mstdout,"density=%.1f%%\n", aa.density()*100.);
#ifdef NEVER
  mprintf(IO::mstdout,
	  "diodes=%d, bjts=%d, mosfets=%d, gates=%d subckts=%d\n",
	  STATUS::diodes, STATUS::bjts, STATUS::mosfets,
	  STATUS::gates, STATUS::subckts);
  mprintf(IO::mstdout,
	  "matrix: terms=%d, fills=%d, total=%d, ops=%d\n",
	  STATUS::matrix_terms, STATUS::matrix_fills, STATUS::matrix_total,
	  STATUS::matrix_ops);
#endif
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
