/* d_vccs.cc
 *$Header: /al/acs/src/RCS/d_vccs.cc,v 8.5 95/05/05 00:22:44 al Exp $
 * functions for vccs
 */
#include "ecah.h"
#include "ap.h"
#include "d_vccs.h"
#include "io.h"
#include "declare.h"
/*--------------------------------------------------------------------------*/
//	void	DEV_VCCS::parse(CS&);
//	void	DEV_VCCS::print(int,int)const;
//	void	DEV_VCCS::expand();
// 	int	DEV_VCCS::dotr();
// 	void	DEV_VCCS::doac();
/*--------------------------------------------------------------------------*/
void DEV_VCCS::parse(CS& cmd)
{
  parselabel(cmd);
  parsenodes(cmd,NUMNODES);
  parseexpr(cmd);
}
/*--------------------------------------------------------------------------*/
void DEV_VCCS::print(int where, int detail)const
{
  printlabel(where);
  printnodes(where,NUMNODES);
  printexpr(where);
  mputc('\n', where);
}
/*--------------------------------------------------------------------------*/
void DEV_VCCS::expand()
{
  assert(loss == 0.);
  m0.f1 = y0.f1 = val;
  y0.f0 = LINEAR;
  m0.c0 = 0.;
  acg = ev = val;
}
/*--------------------------------------------------------------------------*/
int DEV_VCCS::dotr()
{
  if (trfun){
    trsetup();
    m0.x = tr_volts_limited(&(n[IN1]),&(n[IN2]));
    y0.x = m0.x;
    (*trfun)(this);
    m0.c0 = y0.f0 - y0.x * y0.f1;
    m0.f1 = y0.f1;
    trload_active();
    return converged = conv_check();
  }else if (probes){
    trsetup();
    m0.x = tr_volts(&(n[IN1]),&(n[IN2]));
    y0.x = m0.x;
    y0.f0 = y0.x * y0.f1;
    assert(y0.f1 == val);
    assert(m0.f1 == val);
    assert(m0.c0 == 0.);
    trload_active();
    return converged = YES;
  }else{
    assert(m0.f1 == val);
    assert(m0.c0 == 0.);
    trload_active();
    return converged = YES;
  }
}
/*--------------------------------------------------------------------------*/
void DEV_VCCS::doac()
{
  if (acfun){
    acbias = dc_volts(&(n[IN1]),&(n[IN2]));
    ev = (*acfun)(this);
    acg = ev;
  }else if (trfun){
    acg = ev = y0.f1;
  }else{
    assert(acg == val);
  }
  acload_active(); 
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
