/* e_node.cc
 $Header: /al/acs/src/RCS/e_node.cc,v 8.1 95/04/23 18:20:06 al Exp $
 * node probes
 */
#include "ecah.h"
#include "ap.h"
#include "e_node.h"
#include "e_card.h"
#include "u_option.h"
#include "u_probe.h"
#include "u_xprobe.h"
#include "declare.h"
/*--------------------------------------------------------------------------*/
//		NODE::NODE();
//	char*	NODE::printlabel(int where=0)const;
//	double	NODE::probe_tr_num(const char*)const;
//	xprobe_t NODE::probe_ac_ext(const char*)const;
//	double	NODE::logicval()const;
/*--------------------------------------------------------------------------*/
extern const struct nodestuff ns;
/*--------------------------------------------------------------------------*/
NODE::NODE()
{
  diter = aiter = number = 0;
  family = NULL;
  finaltime = lastchange = dt = 0.;
  lv0 = lv1 = ls0 = ls1 = 0;
  nodemode = mANALOG;
  quality = qBAD;
  needslu = NO;
  needsanalog = NO;
  failuremode = "";
}
/*--------------------------------------------------------------------------*/
char* NODE::printlabel(int where)const
{
  static char buffer[BUFLEN];
  sprintf(buffer, "%u", number);
  return buffer;
}
/*--------------------------------------------------------------------------*/
double NODE::probe_tr_num(const char* what)const
{
  CS cmd(what);
  
  node_t nn;
  node_t ground;
  ground.e = ground.m = ground.t = 0;
  nn.e = number;
  nn.t = nn.e;
  nn.m = ns.nm[nn.t];
  
  if (cmd.pmatch("V")){
    return ns.v0[ns.nm[number]];
  }else if (cmd.pmatch("Z")){
    return trz(nn,ground,0.);
  }else if (cmd.pmatch("Logic")){
    return logicval();
  }else if (cmd.pmatch("LAstchange")){
    return lastchange;
  }else if (cmd.pmatch("FInaltime")){
    return finaltime;
  }else if (cmd.pmatch("DIter")){
    return (double)diter;
  }else if (cmd.pmatch("AIter")){
    return (double)aiter;
  }else if (cmd.pmatch("COUNT")){
    return (double)needsanalog;
  }else{ /* bad parameter */
    return NOT_VALID;
  }
}
/*--------------------------------------------------------------------------*/
xprobe_t NODE::probe_ac_ext(const char* what)const
{
  CS cmd(what);
  xprobe_t result(0., mtMAG, 20., YES);
  
  node_t nn;
  node_t ground;
  ground.e = ground.m = ground.t = 0;
  nn.e = number;
  nn.t = nn.e;
  nn.m = ns.nm[nn.t];
  
  if (cmd.pmatch("V")){
    result.value = ns.ac[ns.nm[number]];
  }else if (cmd.pmatch("Z")){
    result.value = acz(nn,ground,complex(0.));
  }else{ /* bad parameter */
    result.value = complex(NOT_VALID, NOT_VALID);
    result.ok = NO;
  }
  return result;
}
/*--------------------------------------------------------------------------*/
double NODE::logicval()const  /* cryptic interpretation of logic value */
{
  return (	   (2*lv0 + lv1)
	  + (.1  * (OPT::transits - quality))
	  + (.01 * (2 - nodemode)));
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
