/* fft.c
 $Header: /al/acs/src/RCS/m_fft.cc,v 8.1 95/04/23 18:20:16 al Exp $
 * fast fourier transform
 */
#include "ecah.h"
#include "declare.h"
/*--------------------------------------------------------------------------*/
	void	fft(complex*,int,int);
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
void fft(complex *x, int n, int inv)
{
 complex w, t;
 int s, nxp, nxp2, m;
 double wpwr, argg;
 
 s = (inv) ? 1 : -1;
 for (nxp=n  ;	(nxp2=nxp/2) > 0  ;  nxp=nxp2){
    wpwr = kPIx2 / nxp;
    for (m=0 ;	 m<nxp2 ;  m++){
       register int j1, j2;
       argg = m * wpwr;
       w = complex(cos(argg),s*sin(argg));
       for (j1=m  ;  j1+nxp-m<=n  ;  j1+=nxp){
	  j2 = j1 + nxp2;
	  t = x[j1] - x[j2];
	  x[j1] += x[j2];
	  x[j2] = t * w;
       }
    }
 }
 /* unscramble */
 {
    register int j, k;
    int i;
    for (i=j=0 ;  i<n-1 ;  i++, j+=k){
       if (i<j){
	  t    = x[j];
	  x[j] = x[i];
	  x[i] = t;
       }
       for (k=n/2 ;  k<=j ;  k/=2)
	  j -= k;
    }
 }
 /* fix level */
 {
    if (!inv){
       register int i;
       register int nn;
       nn = n;
       for ( i=0 ;  i<nn ;  i++ ){
	  x[i] /= nn;
       }
    }
 }
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
